(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('@angular/core'), require('@angular/http'), require('marked'), require('rxjs/add/observable/throw'), require('rxjs/add/operator/catch'), require('rxjs/add/operator/map'), require('rxjs/Observable')) :
	typeof define === 'function' && define.amd ? define(['@angular/core', '@angular/http', 'marked', 'rxjs/add/observable/throw', 'rxjs/add/operator/catch', 'rxjs/add/operator/map', 'rxjs/Observable'], factory) :
	(global.ngx = global.ngx || {}, global.ngx.markdown = factory(global.ng.core,global.ng.http,global.marked,global.rxjs.throw,global.rxjs.catch,global.rxjs.map,global.rxjs.observable));
}(this, (function (core_1,http,marked,_throw,_catch,map,Observable) { 'use strict';

core_1 = core_1 && core_1.hasOwnProperty('default') ? core_1['default'] : core_1;
http = http && http.hasOwnProperty('default') ? http['default'] : http;
marked = marked && marked.hasOwnProperty('default') ? marked['default'] : marked;
_throw = _throw && _throw.hasOwnProperty('default') ? _throw['default'] : _throw;
_catch = _catch && _catch.hasOwnProperty('default') ? _catch['default'] : _catch;
map = map && map.hasOwnProperty('default') ? map['default'] : map;
Observable = Observable && Observable.hasOwnProperty('default') ? Observable['default'] : Observable;

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};





function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var LanguagePipe = (function () {
    function LanguagePipe() {
    }
    LanguagePipe.prototype.transform = function (value, language) {
        if (typeof value !== 'string') {
            console.error("LanguagePipe has been invoked with an invalid value type [" + value + "]");
            return value;
        }
        if (typeof language !== 'string') {
            console.error("LanguagePipe has been invoked with an invalid parameter [" + language + "]");
            return value;
        }
        return '```' + language + '\n' + value + '\n```';
    };
    LanguagePipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'language',
                },] },
    ];
    /** @nocollapse */
    LanguagePipe.ctorParameters = function () { return []; };
    return LanguagePipe;
}());
var LanguagePipe_1 = LanguagePipe;


var language_pipe = {
	LanguagePipe: LanguagePipe_1
};

var MarkedOptions = (function () {
    function MarkedOptions() {
    }
    return MarkedOptions;
}());
var MarkedOptions_1 = MarkedOptions;


var markedOptions = {
	MarkedOptions: MarkedOptions_1
};

var MarkdownService = (function () {
    function MarkdownService(http$$1, options) {
        this.http = http$$1;
        this.options = options;
        if (!this.renderer) {
            this.renderer = new marked.Renderer();
        }
    }
    Object.defineProperty(MarkdownService.prototype, "renderer", {
        get: function () {
            return this.options.renderer;
        },
        set: function (value) {
            this.options.renderer = value;
        },
        enumerable: true,
        configurable: true
    });
    MarkdownService.prototype.compile = function (markdown, markedOptions$$1) {
        if (markedOptions$$1 === void 0) { markedOptions$$1 = this.options; }
        var precompiled = this.precompile(markdown);
        return marked(precompiled, markedOptions$$1);
    };
    MarkdownService.prototype.getSource = function (src) {
        var _this = this;
        return this.http
            .get(src)
            .catch(function (error) { return _this.handleError(error); })
            .map(function (data) { return _this.extractData(data); })
            .map(function (markdown) { return _this.handleExtension(src, markdown); });
    };
    MarkdownService.prototype.highlight = function () {
        if (!window['Prism']) {
            return;
        }
        window['Prism'].highlightAll(false);
    };
    MarkdownService.prototype.extractData = function (response) {
        return response.text() || '';
    };
    MarkdownService.prototype.handleError = function (error) {
        var errMsg;
        if (error instanceof http.Response) {
            var body = error.json() || '';
            var err = body.error || JSON.stringify(body);
            errMsg = error.status + " - " + (error.statusText || '') + " " + err;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error(errMsg);
        return Observable.Observable.throw(errMsg);
    };
    MarkdownService.prototype.handleExtension = function (src, markdown) {
        var extension = src
            ? src.split('.').splice(-1).join()
            : null;
        return extension !== 'md'
            ? '```' + extension + '\n' + markdown + '\n```'
            : markdown;
    };
    MarkdownService.prototype.precompile = function (markdown) {
        if (!markdown) {
            return '';
        }
        var indentStart;
        return markdown
            .replace(/\&gt;/g, '>')
            .split('\n')
            .map(function (line) {
            // find position of 1st non-whitespace character
            // to determine the markdown indentation start
            if (line.length > 0 && isNaN(indentStart)) {
                indentStart = line.search(/\S|$/);
            }
            // remove whitespaces before indentation start
            return indentStart
                ? line.substring(indentStart)
                : line;
        }).join('\n');
    };
    MarkdownService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MarkdownService.ctorParameters = function () { return [
        { type: http.Http, },
        { type: markedOptions.MarkedOptions, },
    ]; };
    return MarkdownService;
}());
var MarkdownService_1 = MarkdownService;


var markdown_service = {
	MarkdownService: MarkdownService_1
};

var MarkdownComponent = (function () {
    function MarkdownComponent(element, markdownService) {
        this.element = element;
        this.markdownService = markdownService;
    }
    Object.defineProperty(MarkdownComponent.prototype, "data", {
        get: function () { return this._data; },
        set: function (value) {
            this._data = value;
            this.render(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkdownComponent.prototype, "src", {
        get: function () { return this._src; },
        set: function (value) {
            var _this = this;
            this._src = value;
            this.markdownService
                .getSource(value)
                .subscribe(function (markdown) { return _this.render(markdown); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkdownComponent.prototype, "isTranscluded", {
        get: function () {
            return !this.data && !this.src;
        },
        enumerable: true,
        configurable: true
    });
    MarkdownComponent.prototype.ngAfterViewInit = function () {
        if (this.isTranscluded) {
            this.render(this.element.nativeElement.innerHTML);
        }
    };
    MarkdownComponent.prototype.render = function (markdown) {
        this.element.nativeElement.innerHTML = this.markdownService.compile(markdown);
        this.markdownService.highlight();
    };
    MarkdownComponent.decorators = [
        { type: core_1.Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'markdown, [markdown]',
                    template: '<ng-content></ng-content>',
                    styles: [":host /deep/ table{border-spacing:0;border-collapse:collapse;margin-bottom:16px}:host /deep/ table td,:host /deep/ table th{padding:6px 13px;border:1px solid #ddd}:host /deep/ table tr:nth-child(2n){background-color:rgba(0,0,0,.03)}:host /deep/ blockquote{padding:0 1em;color:rgba(0,0,0,.535);border-left:.25em solid rgba(0,0,0,.11)}"],
                },] },
    ];
    /** @nocollapse */
    MarkdownComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: markdown_service.MarkdownService, },
    ]; };
    MarkdownComponent.propDecorators = {
        'data': [{ type: core_1.Input },],
        'src': [{ type: core_1.Input },],
    };
    return MarkdownComponent;
}());
var MarkdownComponent_1 = MarkdownComponent;


var markdown_component = {
	MarkdownComponent: MarkdownComponent_1
};

var MarkdownPipe = (function () {
    function MarkdownPipe(markdownService, zone) {
        this.markdownService = markdownService;
        this.zone = zone;
    }
    MarkdownPipe.prototype.transform = function (value) {
        var _this = this;
        if (typeof value !== 'string') {
            console.error("MarkdownPipe has been invoked with an invalid value type [" + value + "]");
            return value;
        }
        var markdown = this.markdownService.compile(value);
        this.zone.runOutsideAngular(function () {
            // glitch in the UI... need a better way to handle this!
            setTimeout(function () { return _this.markdownService.highlight(); });
        });
        return markdown;
    };
    MarkdownPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'markdown',
                },] },
    ];
    /** @nocollapse */
    MarkdownPipe.ctorParameters = function () { return [
        { type: markdown_service.MarkdownService, },
        { type: core_1.NgZone, },
    ]; };
    return MarkdownPipe;
}());
var MarkdownPipe_1 = MarkdownPipe;


var markdown_pipe = {
	MarkdownPipe: MarkdownPipe_1
};

var markdown_module = createCommonjsModule(function (module, exports) {
exports.initialMarkedOptions = {
    provide: markedOptions.MarkedOptions,
    useValue: {
        gfm: true,
        tables: true,
        breaks: false,
        pedantic: false,
        sanitize: false,
        smartLists: true,
        smartypants: false,
    },
};
var MarkdownModule = (function () {
    function MarkdownModule() {
    }
    MarkdownModule.forRoot = function (markedOptions$$2) {
        return {
            ngModule: MarkdownModule,
            providers: [
                markdown_service.MarkdownService,
                markedOptions$$2 || exports.initialMarkedOptions,
            ],
        };
    };
    MarkdownModule.forChild = function () {
        return {
            ngModule: MarkdownModule,
        };
    };
    MarkdownModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [http.HttpModule],
                    exports: [
                        language_pipe.LanguagePipe,
                        markdown_component.MarkdownComponent,
                        markdown_pipe.MarkdownPipe,
                    ],
                    declarations: [
                        language_pipe.LanguagePipe,
                        markdown_component.MarkdownComponent,
                        markdown_pipe.MarkdownPipe,
                    ],
                },] },
    ];
    /** @nocollapse */
    MarkdownModule.ctorParameters = function () { return []; };
    return MarkdownModule;
}());
exports.MarkdownModule = MarkdownModule;

});

var markdown_module_1 = markdown_module.initialMarkedOptions;
var markdown_module_2 = markdown_module.MarkdownModule;

var __extends = (commonjsGlobal && commonjsGlobal.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};

var MarkedRenderer = (function (_super) {
    __extends(MarkedRenderer, _super);
    function MarkedRenderer() {
        _super.apply(this, arguments);
    }
    return MarkedRenderer;
}(marked.Renderer));
var MarkedRenderer_1 = MarkedRenderer;


var markedRenderer = {
	MarkedRenderer: MarkedRenderer_1
};

var lib = createCommonjsModule(function (module, exports) {
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
__export(language_pipe);
__export(markdown_component);
__export(markdown_module);
__export(markdown_pipe);
__export(markdown_service);
__export(markedOptions);
__export(markedRenderer);

});

return lib;

})));
