"use strict";
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var language_pipe_1 = require('./language.pipe');
var markdown_component_1 = require('./markdown.component');
var markdown_pipe_1 = require('./markdown.pipe');
var markdown_service_1 = require('./markdown.service');
var marked_options_1 = require('./marked-options');
exports.initialMarkedOptions = {
    provide: marked_options_1.MarkedOptions,
    useValue: {
        gfm: true,
        tables: true,
        breaks: false,
        pedantic: false,
        sanitize: false,
        smartLists: true,
        smartypants: false,
    },
};
var MarkdownModule = (function () {
    function MarkdownModule() {
    }
    MarkdownModule.forRoot = function (markedOptions) {
        return {
            ngModule: MarkdownModule,
            providers: [
                markdown_service_1.MarkdownService,
                markedOptions || exports.initialMarkedOptions,
            ],
        };
    };
    MarkdownModule.forChild = function () {
        return {
            ngModule: MarkdownModule,
        };
    };
    MarkdownModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [http_1.HttpModule],
                    exports: [
                        language_pipe_1.LanguagePipe,
                        markdown_component_1.MarkdownComponent,
                        markdown_pipe_1.MarkdownPipe,
                    ],
                    declarations: [
                        language_pipe_1.LanguagePipe,
                        markdown_component_1.MarkdownComponent,
                        markdown_pipe_1.MarkdownPipe,
                    ],
                },] },
    ];
    /** @nocollapse */
    MarkdownModule.ctorParameters = function () { return []; };
    return MarkdownModule;
}());
exports.MarkdownModule = MarkdownModule;
//# sourceMappingURL=markdown.module.js.map